var jogador = "";	// Jogador ativo
var vitorias = 0;	// Quantidade de Vitrias
var derrotas = 0;	// Quantidade de derrotas


// Rotina de Inicializao da Pgina
window.onload = init;
function init() {
	// Configura boto "Incio" para acionar funo "iniciaJogo".
	var binicio = document.getElementById("binicio");
	binicio.onclick = iniciaJogo;
	// Ajusta placar
	atualizaPlacar();
	// Cria rea de Debug
	debug();
	}

// Rotina de incio de jogo
function iniciaJogo() {
	// Toca som no incio do jogo
	toca("som_inicio");
	// Pega referncia para radio box de id "x"
	var jogx = document.getElementById("x");
	// Define "x" ou "o" para o jogador, de acordo com sua escolha
	if (jogx.checked) jogador = "x";
	else jogador = "o";
	// Mostra mensagem de incio de jogo
	mostraMensagem("Incio de Jogo", "Jogador: " + jogador);
	// Envia requisio para o servidor para configurar incio de jogo
	enviarRequest("start=" + jogador);
	}

// Mostra janela de mensagem ao usurio
function mostraMensagem(titulo, mensagem) {
	// Originalmente usava o Window Alert
	//window.alert(mensagem, titulo);

	// Vamos preencher a janela com contedo
	var jan = document.getElementById("janelaconteudo");
	// Cria titulo
	var tit = document.createElement("h1");
	tit.innerHTML = titulo;
	jan.appendChild(tit);
	// Cria mensagem
	var msg = document.createElement("p");
	msg.innerHTML = mensagem;
	jan.appendChild(msg);

	// Cria o boto de fechamento da janela
	var botao = document.createElement("button");
	botao.innerHTML = "Ok";
	botao.onclick = escondeMensagem;
	jan.appendChild(botao);

	// Vamos mostrar a janela
	//var fundo = document.getElementById("janela");
	//fundo.style.display = "block";
	$("#janela").fadeIn();
	}

// Esconde mensagem quando ela  fechada
function escondeMensagem() {
	// Vamos esconder a janela
	//var fundo = document.getElementById("janela");
	//fundo.style.display = "none";
	$("#janela").fadeOut(limpaMensagem);
	}

// Limpa conteudo da janela
function limpaMensagem() {
	var jan = document.getElementById("janelaconteudo");
	jan.innerHTML = "";
	}

// Futuramente enviar requisio para o servidor, com o comando
// Por hora desenha o tabuleiro
function enviarRequest(comando) {
	pintaTabuleiro("..........");
	}

function pintaTabuleiro(dados) {
	// Verifica estado do tabuleiro
	// Testa cada uma das clulas
	for (i=0; i<=8; i++) {
		// Pega cdigo: "x", "X", "o", "O" ou "."
		var c = dados.substr(i,1);
		// Pega referncia para clula e sua sobreposta
		var cel = document.getElementById("c" + i);
	   	var scel = document.getElementById("c" + i + "s");
		// Se for uma clula j selecionada...
	   	if (c == "x" || c == "X" || c == "o" || c == "O") {
	   		// Ajusta classe da clula (muda imagem de fundo)
			cel.className = c + "sel";
			// Esconde sobreposta, para no aparecer "azul"
	      		scel.style.visibility = "hidden";
	      		// Desliga click sobre a clula
	      		cel.onclick = "";
   	   		}
   	   	// Caso contrrio, clula ainda vazia
   	   	else {
   	   		// Limpa imagem de fundo (clula vazia)
			cel.className = "";
			// Mostra sobreposta, para aparcer "azul"
	      		scel.style.visibility = "visible";
	      		// Liga click na clula
	      		cel.onclick = click;
	   		}
		}

	// Verifica estado de vitria/derrota do jogo
	var r = dados.substr(9,1);
	// Se for vitria
	if (r == "v") {
		toca("som_vitoria");
		mostraMensagem("Voc venceu!",
			"Parabns! Ser que consegue me vencer novamente?");
		// Atualiza contador de vitrias
		vitorias = vitorias + 1;
		localStorage.vitorias = Number(localStorage.vitorias)+1;
	}
	// Se for derrota
	else if (r == "d") {
		toca("som_derrota");
		mostraMensagem("Voc perdeu!",
			"Que pena! Desejo mais sorte na prxima vez!");
		// Atualiza contador de derrotas
		derrotas = derrotas + 1;
		localStorage.derrotas = Number(localStorage.derrotas)+1;
	// Se for empate
	} else if (r == "e") {
		toca("som_derrota");
		mostraMensagem("Deu velha!",
			"Somos bons! Com o tempo voc pode me superar!");
	}

	// Se jogo acabou (vitria, derrota ou empate), desliga todo tabuleiro
	if (r == "v" || r == "d" || r == "e") {
		for (i=0; i<=8; i++) {
			var cel = document.getElementById("c" + i);
			var scel = document.getElementById("c" + i + "s");
			scel.style.visibility = "hidden";
			cel.onclick = "";
   	   		}
		}

	// Ajusta placar na tela
	atualizaPlacar();
	}

// Atua quando usurio clica em uma clula
function click() {
	// Muda fundo de clula clicada (temporrio
	this.className = jogador+"sel";
	// Toca som de jogada
	toca("som_pop");
	// Futuramente chamada enviaRequest("cel=c" + this.id);
	}

function atualizaPlacar() {
    // Se banco de dados est vazio, inicia com 0
    if (localStorage.derrotas == null) {
         localStorage.vitorias = 0;
         localStorage.derrotas = 0;
    }
    // Preenche placar com texto
    var ref = document.getElementById("status_hoje");
    ref.innerHTML = "<strong>Agora</strong> V: " + vitorias + " / D: " + derrotas;
    ref = document.getElementById("status_total");
    ref.innerHTML = "<strong>Total</strong> V: " + localStorage.vitorias + " / D: " + localStorage.derrotas;
}

function toca(id) {
	document.getElementById(id).play();
}



function debug() {
   var div = document.createElement("div");
   div.id = "debug";
   div.style.position = "fixed";
   div.style.right = "0px";
   div.style.top = "0px";
   div.style.borderWidth = "2px";
   div.style.borderColor = "blue";
   div.style.borderStyle = "solid";
   div.style.padding = "5px";

   /* Cria Campo de Entrada */
   var entrada = document.createElement("input");
   entrada.type = "text";
   entrada.id = "dbg_entrada";
   div.appendChild(entrada);

   var botao = document.createElement("button");
   botao.innerHTML = "Testar!";
   botao.onclick = rodaDebug;
   div.appendChild(botao);

   document.body.appendChild(div);
}

function rodaDebug() {
   var entrada = document.getElementById("dbg_entrada");
   pintaTabuleiro(entrada.value);
}

